1 'GR8BUS master LAN module
2 'test program
3 'Copyleft 2012 Eugeny Brychkov
4 'Please refer to license supplied
5 'with this software
6 '--------------------------------
10 'Gateway IP address
20 G0$="192":G1$="168":G2$="1":G3$="1"
30 'IP address mask
40 M0$="255":M1$="255":M2$="255":M3$="0"
50 'Hardware MAC address
60 H0=0:H1=8:H2=&HDC:H3=1:H4=2:H5=3
70 'GR8BUS LAN module's IP address
80 I0$="192":I1$="168":I2$="1":I3$="20"
90 'Local port
100 P$="5000"
110 'Remote IP address (one of www.google.com)
120 R0$="74":R1$="125":R2$="143":R3$="99"
130 'Remote server port
140 RP$="80" 'HTTP
150 '------- Configuring the chip -------
160 PRINT"Detecting W5100..."
170 OUT&HAC,0:OUT&HAD,0
180 OUT&HAE,&H10
190 IF INP(&HAE)<>16 GOTO 1490
200 OUT&HAE,&H80
210 IF INP(&HAE)<>0 GOTO 1490
220 PRINT"Configuring..."
230 PRINT"GW IP ";CHR$(9);G0$;".";G1$;".";G2$;".";G3$
240 OUT&HAC,1:OUT&HAE,VAL(G0$)
250 OUT&HAC,2:OUT&HAE,VAL(G1$)
260 OUT&HAC,3:OUT&HAE,VAL(G2$)
270 OUT&HAC,4:OUT&HAE,VAL(G3$)
280 PRINT"Mask ";CHR$(9);M0$;".";M1$;".";M2$;".";M3$
290 OUT&HAC,5:OUT&HAE,VAL(M0$)
300 OUT&HAC,6:OUT&HAE,VAL(M1$)
310 OUT&HAC,7:OUT&HAE,VAL(M2$)
320 OUT&HAC,8:OUT&HAE,VAL(M3$)
330 PRINT"MAC ";CHR$(9);HEX$(H0);":";HEX$(H1);":";HEX$(H2);":";HEX$(H3);":";HEX$(H4);":";HEX$(H5)
340 OUT&HAC,&H9:OUT&HAE,VAL(H0$)
350 OUT&HAC,&HA:OUT&HAE,VAL(H1$)
360 OUT&HAC,&HB:OUT&HAE,VAL(H2$)
370 OUT&HAC,&HC:OUT&HAE,VAL(H3$)
380 OUT&HAC,&HD:OUT&HAE,VAL(H4$)
390 OUT&HAC,&HE:OUT&HAE,VAL(H5$)
400 PRINT"IP ";CHR$(9);I0$;".";I1$;".";I2$;".";I3$
410 OUT&HAC,&HF:OUT&HAE,VAL(I0$)
420 OUT&HAC,&H10:OUT&HAE,VAL(I1$)
430 OUT&HAC,&H11:OUT&HAE,VAL(I2$)
440 OUT&HAC,&H12:OUT&HAE,VAL(I3$)
450 'initialize socket 0, TCP
460 '------- Initializing sockets -------
470 PRINT"Initializing (P=";P$;")...";
480 OUT&HAD,&H4
490 OUT&HAC,&H0:OUT&HAE,1
500 OUT&HAC,&H4:OUT&HAE,VAL(P$)/256
510 OUT&HAC,&H5:OUT&HAE,VAL(P$) MOD 256
520 OUT&HAC,&H1:OUT&HAE,1
530 OUT&HAC,&H3
540 C=256
550 FOR I=0 TO 1000:A=INP(&HAE)
560 IF A<>C THEN PRINTHEX$(A);" ";:C=A
570 IF A=&H13 THEN PRINT:GOTO 610
580 NEXT I
590 GOTO 1500
600 '------- Connecting to remote host -------
610 PRINT"Connecting..."
620 PRINT"IP ";CHR$(9);R0$;".";R1$;".";R2$;".";R3$:PRINT"Port";CHR$(9);RP$
630 OUT&HAC,&HC:OUT&HAE,VAL(R0$)
640 OUT&HAC,&HD:OUT&HAE,VAL(R1$)
650 OUT&HAC,&HE:OUT&HAE,VAL(R2$)
660 OUT&HAC,&HF:OUT&HAE,VAL(R3$)
670 OUT&HAC,&H10:OUT&HAE,VAL(RP$)/256
680 OUT&HAC,&H11:OUT&HAE,VAL(RP$) MOD 256
690 PRINT"Progress: ";
700 OUT&HAC,&H1:OUT&HAE,4
710 OUT&HAC,&H3
720 C=256
730 FOR I=0 TO 10000:A=INP(&HAE)
740 IF A<>C THEN PRINTHEX$(A);" ";:C=A
750 IF A=&H17 THEN PRINT:GOTO 780
760 NEXT I
770 GOTO 1510
780 ' prepare pointers/counters
790 OUT&HAC,&H20:A=INP(&HAE)*256
800 OUT&HAC,&H21:A=A+INP(&HAE)
810 PRINT"Preparing... (";HEX$(A);"h free)";CHR$(10);
820 IF A<128 GOTO 780
830 PRINT
840 'dest IP and port is already there
850 OUT&HAC,&H24:A=(INP(&HAE) AND &H7)*256
860 OUT&HAC,&H25:A=A+INP(&HAE)
870 Q=A:B=&H4000+A
880 '------- Preparing data to send -------
890 ' prepare data to send
900 S$="GET / HTTP/1.0"+CHR$(13)+CHR$(10)+CHR$(13)+CHR$(10)
910 L=LEN(S$)
920 FOR I=1 TO L
930 OUT&HAC,B MOD 256
940 OUT&HAD,B/256
950 C=ASC(MID$(S$,I,1))
960 OUT&HAE,C
970 PRINTCHR$(C);
980 B=B+1:A=A+1
990 IF A=&H800 THEN A=0:B=&H4000
1000 NEXT I
1010 PRINT
1020 OUT&HAC,&H24:OUT&HAD,&H4
1030 A=(INP(&HAE) AND &H7)*256
1040 OUT&HAC,&H25
1050 A=A+INP(&HAE)
1060 A=A+L
1070 OUT&HAC,&H24
1080 OUT&HAE,A/256
1090 OUT&HAC,&H25
1100 OUT&HAE,A MOD 256
1110 ' initiating SEND command
1120 PRINT"Sending... (";HEX$(Q);"-";HEX$(A);"), code ";
1130 OUT&HAC,1:OUT&HAE,&H20
1140 OUT&HAC,&H3
1150 C=256
1160 FOR I=0 TO 1000:A=INP(&HAE)
1170 IF A<>C THEN PRINTHEX$(A);" ";:C=A
1180 IF A=&H17 THEN PRINT:GOTO 1210
1190 GOTO 1520
1200 '------- Receiving remote host reply -------
1210 ' receiving data
1220 PRINT"Waiting to receive..."
1230 FOR J=0 TO 1000
1240 OUT&HAC,&H26:A=(INP(&HAE) AND &H7)*256
1250 OUT&HAC,&H27:A=A+INP(&HAE)
1260 IF A<>0 GOTO 1320
1270 OUT&HAC,3
1280 A=INP(&HAE)
1290 IF A<>&H17 GOTO 1520
1300 NEXT J
1310 GOTO 1530
1320 OUT&HAC,&H28:B=(INP(&HAE) AND &H7)*256
1330 OUT&HAC,&H29:B=B+INP(&HAE)
1340 PRINT"Received 0";HEX$(A);"h bytes"
1350 PRINT:PRINT"------------------------------"
1360 B=B+&H6000
1370 FOR I=1 TO A
1380 OUT&HAC,B MOD 256:OUT&HAD,B/256
1390 PRINTCHR$(INP(&HAE));
1400 B=B+1:IF B=&H6800 THEN B=&H6000
1410 NEXT I
1420 OUT&HAD,&H4
1430 OUT&HAC,&H28:OUT&HAE,B/256
1440 OUT&HAC,&H29:OUT&HAE,B MOD 256
1450 OUT&HAC,1:OUT&HAE,&H40
1460 GOTO 1240
1470 PRINT"Configured.":STOP
1480 '------- Termination messages -------
1490 PRINT:PRINT"No W5100 detected":STOP
1500 PRINT:PRINT"Init error, ";:GOTO 1540
1510 PRINT:PRINT"Connect error, ";:GOTO 1540
1520 PRINT:PRINT"Terminated, ";:GOTO 1540
1530 PRINT:PRINT"Timeout, ";:GOTO 1540
1540 OUT&HAC,&H3:A=INP(&HAE):PRINTHEX$(A)
1550 IF A=0 THEN PRINT"Connection closed"
1560 STOP
